#include "SDL.h"
#include "rectangle.h"

//Kd - wspolczynnik odbicia rozproszonego
//Ks - wspolczynnik odbicia kierunkowego
CRectangle::CRectangle(double Kd, double Ks, short SpecIndex, 
				 short Xcentre, short Ycentre, short radius, 
				 SDL_Surface *screen) {

	 
	//Ia - natezenie swiatla w otoczeniu obiektu; Ka - wspolczynnik odbicia tla
	IaKa = 0.2; //iloczyn 
	
	//H - wektor normalny do hipotetycznej powierzchni (h - dwusieczna kata miedzy L i V)
	/*Hx = 0.326058;
	Hy = 0.325058;
	Hz = 0.888074;*/
	
	//natezenie zrodla swiatla (punktowego)
	Ilight = 140;
	
	//wspolczynnik do tlumienia wraz z odlegloscia
	K = 70;
	dx = 10; dy = 10; dz =200;
	
	//wektor skierowany do zrodla swiatla
	Lx = 0.57735; 
	Ly = 0.57735; 
	Lz = 0.57735;
	
	//wynikowe natezenie swiatla (Ir)
	float Ir;

	int x, y, z;
	float rsquare, xsquare, ysquare, zsquare, denom, xn, yn, zn, LdotN, NnH,
		  dist, distfactor, ambientterm, diffuseterm, specularterm;

	rsquare = radius * radius;

	for (y = -radius; y<radius; y++) {
		ysquare = y * y;
		for (x = -radius; x<radius; x++) {
			xsquare = x * x;
				z = 100;
				zsquare = z * z;
				denom = sqrt(xsquare + ysquare + zsquare);
				
				// xn, yn, i zn wektor normalny do powierzchni (punktu na pow. o wsp. x,y,z)
				xn = x / denom;
				yn = y / denom;
				zn = z / denom;

				CalculateLNandNnH(x, y, z, SpecIndex, xn, yn, zn, &LdotN, &dist, &NnH); 

				//czynnik oswitlenia tla
				ambientterm = IaKa;

				if (LdotN <= 0) {
					Ir = 64 * ambientterm; //tylko oswietlenie tla
				}
				else {
					distfactor = Ilight / (dist + K);		//tlumienie zrodla wraz z odlegloscia 
					diffuseterm = distfactor * Kd * LdotN;	//odbicie rozproszone
					specularterm = distfactor * Ks * NnH;	//odbicie kierunkowe
					Ir = 64 * (ambientterm + diffuseterm + specularterm);
				}
				pixelRGBA(screen,Xcentre + x, Ycentre + y, 150+Ir,Ir,Ir,255); //putpixel SDL_gfx
		}//for-wew
	}//for-zew
}